/******************************************************************************
 * Product: Compiere ERP & CRM Smart Business Solution                        *
 * Copyright (C) 1999-2007 ComPiere, Inc. All Rights Reserved.                *
 * This program is free software, you can redistribute it and/or modify it    *
 * under the terms version 2 of the GNU General Public License as published   *
 * by the Free Software Foundation. This program is distributed in the hope   *
 * that it will be useful, but WITHOUT ANY WARRANTY, without even the implied *
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           *
 * See the GNU General Public License for more details.                       *
 * You should have received a copy of the GNU General Public License along    *
 * with this program, if not, write to the Free Software Foundation, Inc.,    *
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.                     *
 * For the text or an alternative of this public license, you may reach us    *
 * ComPiere, Inc., 3600 Bridge Parkway #102, Redwood City, CA 94065, USA      *
 * or via info@compiere.org or http://www.compiere.org/license.html           *
 *****************************************************************************/
package org.compiere.translate;

import java.util.*;

/**
 *  Translation Texts for Look & Feel
 *
 *  @author     Jorg Janke
 *  @version    $Id: PlafRes_da.java,v 1.1 2008/07/29 16:04:20 jrmt Exp $
 */
public class PlafRes_da extends ListResourceBundle
{
	/** The data    */
	static final Object[][] contents = new String[][]
	{
	{ "BackColType",            "Baggrund: Farvetype" },
	{ "BackColType_Flat",       "Fast" },
	{ "BackColType_Gradient",   "Farveforl\u00f8b" },
	{ "BackColType_Lines",      "Linjer" },
	{ "BackColType_Texture",    "Struktur" },
	//
	{ "LookAndFeelEditor",      "Redig\u00e9r & udseende" },
	{ "LookAndFeel",            "Udseende" },
	{ "Theme",                  "Tema" },
	{ "EditCompiereTheme",      "Redig\u00e9r Compiere tema" },
	{ "SetDefault",             "Baggrund: Standard" },
	{ "SetDefaultColor",        "Baggrundsfarve" },
	{ "ColorBlind",             "Farvereduktion" },
	{ "Example",                "Eksempel" },
	{ "Reset",                  "Gendan" },
	{ "OK",                     "OK" },
	{ "Cancel",                 "Annull\u00e9r" },
	//
	{ "CompiereThemeEditor",    "Compiere-tema: Redig\u00e9r" },
	{ "MetalColors",            "Metal-farver" },
	{ "CompiereColors",         "Compiere-farver" },
	{ "CompiereFonts",          "Compiere-skrifttyper" },
	{ "Primary1Info",           "Skygge, Separator" },
	{ "Primary1",               "Prim\u00e6r 1" },
	{ "Primary2Info",           "Markeret element, Markeret menu" },
	{ "Primary2",               "Prim\u00e6r 2" },
	{ "Primary3Info",           "Markeret r\u00e6kke i tabel, Markeret tekst, V\u00e6rkt\u00f8jstip - baggr." },
	{ "Primary3",               "Prim\ufffdr 3" },
	{ "Secondary1Info",         "Rammelinjer" },
	{ "Secondary1",             "Sekund\u00e6r 1" },
	{ "Secondary2Info",         "Ikke-aktive faner, Markerede felter, Ikke-aktiv ramme + tekst" },
	{ "Secondary2",             "Sekund\u00e6r 2" },
	{ "Secondary3Info",         "Baggrund" },
	{ "Secondary3",             "Sekund\u00e6r 3" },
	//
	{ "ControlFontInfo",        "Skrifttype: Knapper" },
	{ "ControlFont",            "Skrifttype: Etiket" },
	{ "SystemFontInfo",         "V\u00e6rkt\u00f8jstip, Strukturknuder" },
	{ "SystemFont",             "Skrifttype: System" },
	{ "UserFontInfo",           "Anvend" },
	{ "UserFont",               "Skrifttype: Felt" },
//	{ "SmallFontInfo",          "Rapporter" },
	{ "SmallFont",              "Lille" },
	{ "WindowTitleFont",         "Skrifttype: Titellinje" },
	{ "MenuFont",               "Skrifttype: Menu" },
	//
	{ "MandatoryInfo",          "Tvungen feltbaggrund" },
	{ "Mandatory",              "Tvungen" },
	{ "ErrorInfo",              "Fejl: Feltbaggrund" },
	{ "Error",                  "Fejl" },
	{ "InfoInfo",               "Info: Feltbaggrund" },
	{ "Info",                   "Info" },
	{ "WhiteInfo",              "Linjer" },
	{ "White",                  "Hvid" },
	{ "BlackInfo",              "Linjer, Tekst" },
	{ "Black",                  "Sort" },
	{ "InactiveInfo",           "Inaktiv feltbaggrund" },
	{ "Inactive",               "Inaktiv" },
	{ "TextOKInfo",             "OK: Tekstforgrund" },
	{ "TextOK",                 "Tekst: OK" },
	{ "TextIssueInfo",          "Fejl: Tekstforgrund" },
	{ "TextIssue",              "Tekst: Fejl" },
	//
	{ "FontChooser",            "Skriftype" },
	{ "Fonts",                  "Skrifttyper" },
	{ "Plain",                  "Normal" },
	{ "Italic",                 "Kursiv" },
	{ "Bold",                   "Fed" },
	{ "BoldItalic",             "Fed & kursiv" },
	{ "Name",                   "Navn" },
	{ "Size",                   "St\u00f8rrelse" },
	{ "Style",                  "Type" },
	{ "TestString",             "Dette er en pr\u00f8ve! 12.3456,78 BogstavLEn = l1 BogstavONul = O0" },
	{ "FontString",             "Skrifttype" },
	//
	{ "CompiereColorEditor",    "Compiere-farveeditor" },
	{ "CompiereType",           "Farvetype" },
	{ "GradientUpperColor",     "Farveforl\u00f8b: Farve 1" },
	{ "GradientLowerColor",     "Farveforl\u00f8b: Farve 2" },
	{ "GradientStart",          "Farveforl\u00f8b: Start" },
	{ "GradientDistance",       "Farveforl\u00f8b: Afstand" },
	{ "TextureURL",             "Struktur: URL" },
	{ "TextureAlpha",           "Struktur: Alpha" },
	{ "TextureTaintColor",      "Struktur: Pletvis" },
	{ "LineColor",              "Linjefarve" },
	{ "LineBackColor",          "Baggrundsfarve" },
	{ "LineWidth",              "Linjebredde" },
	{ "LineDistance",           "Linjeafstand" },
	{ "FlatColor",              "Fast farve" }
	};

	/**
	 * Get Contents
	 * @return contents
	 */
	public Object[][] getContents()
	{
		return contents;
	}
}   //  Res
