/******************************************************************************
 * Product: Compiere ERP & CRM Smart Business Solution                        *
 * Copyright (C) 1999-2007 ComPiere, Inc. All Rights Reserved.                *
 * This program is free software, you can redistribute it and/or modify it    *
 * under the terms version 2 of the GNU General Public License as published   *
 * by the Free Software Foundation. This program is distributed in the hope   *
 * that it will be useful, but WITHOUT ANY WARRANTY, without even the implied *
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           *
 * See the GNU General Public License for more details.                       *
 * You should have received a copy of the GNU General Public License along    *
 * with this program, if not, write to the Free Software Foundation, Inc.,    *
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.                     *
 * For the text or an alternative of this public license, you may reach us    *
 * ComPiere, Inc., 3600 Bridge Parkway #102, Redwood City, CA 94065, USA      *
 * or via info@compiere.org or http://www.compiere.org/license.html           *
 *****************************************************************************/
package org.compiere.translate;

import java.util.*;

/**
 *  Translation Texts for Look & Feel for Finnish Language
 *
 * 	@author 	Petteri Soininen (petteri.soininen@netorek.fi)
 * 	@version 	$Id: PlafRes_fi.java,v 1.1 2008/07/29 16:04:21 jrmt Exp $
 */
public class PlafRes_fi extends ListResourceBundle
{
		/** 
	    * Data 
	    */
		static final Object[][] contents = new String[][]
		{
		{ "BackColType",            "Taustan v\ufffdrityyppi" },
		{ "BackColType_Flat",       "Yksiv\ufffdri" },
		{ "BackColType_Gradient",   "Gradientti" },
		{ "BackColType_Lines",      "Viiva" },
		{ "BackColType_Texture",    "Kuviointi" },
		//
		{ "LookAndFeelEditor",      "K\ufffdytt\ufffdtuntuman muokkaus" },
		{ "LookAndFeel",            "K\ufffdytt\ufffdtuntuma" },
		{ "Theme",                  "Teema" },
		{ "EditCompiereTheme",      "Muokkaa Compiere-teemaa" },
		{ "SetDefault",             "Oletustaustav\ufffdri" },
		{ "SetDefaultColor",        "Taustav\ufffdri" },
		{ "ColorBlind",             "V\ufffdrisokeus" },
		{ "Example",                "Esimerkki" },
		{ "Reset",                  "Nollaa" },
		{ "OK",                     "Hyv\ufffdksy" },
		{ "Cancel",                 "Peruuta" },
		//
		{ "CompiereThemeEditor",    "Compiere-teeman muokkaus" },
		{ "MetalColors",            "Metalliv\ufffdrit" },
		{ "CompiereColors",         "Compiere-v\ufffdrit" },
		{ "CompiereFonts",          "Compiere-kirjasimet" },
		{ "Primary1Info",           "Varjostin, Erotin" },
		{ "Primary1",               "Ensisijainen 1" },
		{ "Primary2Info",           "Focus-viiva, Valitty Valikko" },
		{ "Primary2",               "Ensisijainen 2" },
		{ "Primary3Info",           "Taulun Valittu Rivi, Valittu Teksti, ToolTip Tausta" },
		{ "Primary3",               "Ensisijainen 3" },
		{ "Secondary1Info",         "Reunaviivat" },
		{ "Secondary1",             "Toissijainen 1" },
		{ "Secondary2Info",         "Ei-aktiiviset Tabulaattorit, Painetut Kent\ufffdt, Ei-aktiivinen Reuna + Teksti" },
		{ "Secondary2",             "Toissijainen 2" },
		{ "Secondary3Info",         "Tausta" },
		{ "Secondary3",             "Toissijainen 3" },
		//
		{ "ControlFontInfo",        "Kontrollikirjasin" },
		{ "ControlFont",            "Nimikekirjasin" },
		{ "SystemFontInfo",         "Tool Tip, Puun Solmut" },
		{ "SystemFont",             "J\ufffdrjestelm\ufffdkirjasin" },
		{ "UserFontInfo",           "K\ufffdytt\ufffdj\ufffdn Sy\ufffdtt\ufffdm\ufffd Tieto" },
		{ "UserFont",               "Kentt\ufffdkirjasin" },
//		{ "SmallFontInfo",          "Raportit" },
		{ "SmallFont",              "Pieni Kirjasin" },
		{ "WindowTitleFont",         "Otsikkokirjasin" },
		{ "MenuFont",               "Valikkokirjasin" },
		//
		{ "MandatoryInfo",          "Pakollinen Kentt\ufffdtausta" },
		{ "Mandatory",              "Pakollinen" },
		{ "ErrorInfo",              "Virhekent\ufffdn Tausta" },
		{ "Error",                  "Virhe" },
		{ "InfoInfo",               "Tietokent\ufffdn Tausta" },
		{ "Info",                   "Tieto" },
		{ "WhiteInfo",              "Viivat" },
		{ "White",                  "Valkoinen" },
		{ "BlackInfo",              "Viivat, Teksti" },
		{ "Black",                  "Musta" },
		{ "InactiveInfo",           "Ei-aktiivinen Kentt\ufffdtausta" },
		{ "Inactive",               "Ei-aktiivinen" },
		{ "TextOKInfo",             "Hyv\ufffdksy Teksti Edusta" },
		{ "TextOK",                 "Teksti - Hyv\ufffdksy" },
		{ "TextIssueInfo",          "Virhetekstin Edusta" },
		{ "TextIssue",              "Teksti - Virhe" },
		//
		{ "FontChooser",            "Kirjasimen Valitsin" },
		{ "Fonts",                  "Kirjasimet" },
		{ "Plain",                  "Tavallinen" },
		{ "Italic",                 "Kursiivi" },
		{ "Bold",                   "Lihavoitu" },
		{ "BoldItalic",             "Lihavoitu ja Kursiivi" },
		{ "Name",                   "Nimi" },
		{ "Size",                   "Koko" },
		{ "Style",                  "Tyyli" },
		{ "TestString",             "T\ufffdm\ufffd on vain Testi! Nopea ruskea Kettu suorittaa jotain. 12,3456.78 LetterLOne = l1 LetterOZero = O0" },
		{ "FontString",             "Kirjasin" },
		//
		{ "CompiereColorEditor",    "Compiere-v\ufffdrimuokkaus" },
		{ "CompiereType",           "V\ufffdrityyppi" },
		{ "GradientUpperColor",     "Gradientin Ylempi V\ufffdri" },
		{ "GradientLowerColor",     "Gradientin Alempi V\ufffdri" },
		{ "GradientStart",          "Gradientin Alku" },
		{ "GradientDistance",       "Gradientin Et\ufffdisyys" },
		{ "TextureURL",             "Kuvioinnin URL" },
		{ "TextureAlpha",           "Kuvioinnin Alpha" },
		{ "TextureTaintColor",      "Kuvioinnin Korvausv\ufffdri" },
		{ "LineColor",              "Viivan V\ufffdri" },
		{ "LineBackColor",          "Taustan V\ufffdri" },
		{ "LineWidth",              "Viivan Paksuus" },
		{ "LineDistance",           "Viivan Et\ufffdisyys" },
		{ "FlatColor",              "Tavallinen V\ufffdri" }
		};

	/**
	 * Get Contents
	 * @return contents
	 */
	public Object[][] getContents()
	{
		return contents;
	}
}   //  Res

